=== tests/analysis/CMakeLists.txt ===
add_subdirectory(differentiation)
add_subdirectory(integration)
add_subdirectory(fit)
add_subdirectory(convolution)
add_subdirectory(correlation)
