=== tests/import_export/CMakeLists.txt ===
add_subdirectory(ASCII)
add_subdirectory(JSON)
add_subdirectory(project)
add_subdirectory(MQTT)
