=== debian/watch ===
version=3
https://download.kde.org/stable/labplot/([\d.]+)/labplot-([\d.]+)\.tar\.xz
