## labplot 2.8.0

=== debian/changelog ===
labplot (2.8.0-1) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Repository.
  * Update standards version to 4.5.0, no changes needed.

  [ Pino Toscano ]
  * New upstream release.
  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_missing, as it is the default now
  * Add Rules-Requires-Root: no.
  * Switch Repository to invent.kde.org.
  * Update lintian overrides.
  * Switch Homepage to https://labplot.kde.org/.
  * Update install files.
  * Unregister labplot2_themes.knsrc as conffile, as it is no more in /etc.
  * Upstream now installs the examples, so:
    - stop installing them manually
    - symlink /usr/share/labplot2/example_projects to
      /usr/share/doc/labplot/examples for compatibility

 -- Pino Toscano <pino@debian.org>  Thu, 17 Sep 2020 08:09:59 +0200
