=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  cmake (>= 3.2.0),
  gettext,
  pkg-kde-tools (>= 0.15.16),
@@ -40,10 +40,11 @@
  liblz4-dev,
  xauth,
  xvfb,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/labplot
 Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/labplot.git
-Homepage: https://edu.kde.org/applications/science/labplot/
+Homepage: https://labplot.kde.org/
 
 Package: labplot
 Architecture: any
