=== debian/rules ===
--- 
+++ 
@@ -8,6 +8,3 @@
 override_dh_auto_test:
 	# non-fatal, as tests fail on almost non-amd64 archs
 	-xvfb-run dh_auto_test
-
-override_dh_missing:
-	dh_missing --fail-missing
